from builtin.const import *
from builtin.proto import *
from builtin.utils import *
from builtin.stype import *


class UsrObject:
    """
    空对象, 用于添加自定义属性
    """
    pass


class Point:
    def __init__(self, x, y):
        self.x = x
        self.y = y


P = Point


class std:
    """
    标准库基础函数
    """

    @staticmethod
    def _expand_composite_as_list(filter_composite: tuple | list | set | callable) -> list:
        """
        展开函数容器表达式为list | Expand the function container expression to list
        :param filter_composite: 函数容器表达式 | function container expression
        :return: 展开后的list | expanded list
        """
        pass

    @staticmethod
    def _generate_combo_js_eval(filter_composite: tuple | list | set | callable, fid: dict) -> str:
        """
        生成js表达串 | Generate js expression string
        :param filter_composite: 函数容器表达式 | function container expression
        :param fid: 函数到id的映射 | function to id mapping
        :return: js表达串 | js expression string
        """
        pass

    @staticmethod
    def combo(filter_composite: tuple | list | set | callable) -> callable:
        """
        展开函数容器表达式 | Expand the function container expression

        函数容器表达式是一个由list(表示或)，tuple(表示与), set(表示not)组成的表达式，支持嵌套 |
            The function container expression is an expression composed of list (representing or), tuple (representing and), and set (representing not), supporting nesting

        * 你可以直接使用combo来代替std.combo | You can use combo directly instead of std.combo

        Args:
            filter_composite: 只由tuple、list和set组成的过滤器结构(最小单元是callable) |
                A filter structure consisting only of tuple, list, and set (the smallest unit is callable)

        Returns:
            一个新的可以表达输入表达式的函数 | A new function that can express the input expression
        """
        pass

    @staticmethod
    def log(caller_name: str, *args: str):
        """
        [caller_name Log]: *args

        Args:
            caller_name: 调用者名称 | caller name
            *args: 输出信息 | output information

        Returns:

        """
        pass

    @staticmethod
    def info(caller_name: str, *args: str):
        """
        [caller_name Info]: *args

        Args:
            caller_name: 调用者名称 | caller name
            *args: 输出信息 | output information

        Returns:

        """
        pass

    @staticmethod
    def warn(caller_name: str, *args: str):
        """
        [caller_name Warn]: *args

        Args:
            caller_name: 调用者名称 | caller name
            *args: 输出信息 | output information

        Returns:

        """
        pass

    @staticmethod
    def error(caller_name: str, *args: str):
        """
        [caller_name Error]: *args

        * 会抛出一个js的Error | Will throw a js Error

        Args:
            caller_name: 调用者名称 | caller name
            *args: 输出信息 | output information

        Returns:

        """
        pass

    @staticmethod
    def show_usage():
        pass


# get (game information)
class get:
    ticks = getTicks
    cpu = getCpuTime
    heap = getHeapStatistics
    byid = getObjectById

    @staticmethod
    def cpu_us() -> int:
        """
        获取当前tick已使用的cpu时间, 单位: 微秒

        Returns:
            int
        """
        pass

    @staticmethod
    def arena() -> UsrObject:
        """
        获取arenaInfo对象

        Returns:
            object，包含以下属性:
                name:str The name of the arena.
                level:int Currently equals to 1 for basic arena and 2 for advanced.
                season:str Currently equals to "alpha".
                ticksLimit:int Game ticks limit.
                cpuTimeLimit:int CPU wall time execution limit per one tick (except the first tick).
                cpuTimeLimitFirstTick:int CPU wall time limit on the first tick.
        """
        pass

    @staticmethod
    def path(obj: st.point, target: st.point, options: UsrObject = None) -> list[st.point]:
        """
        返回obj到目标的路径

        Args:
            obj: st.point (X) 一个坐标点
            target: st.point (X) 一个坐标点
            options: UsrObject (X) 路径查找的选项

        Returns:
            list[st.point] 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def distance(obj: st.point, target: st.point) -> int:
        """
        返回obj到目标的距离(单位: 方块数)

        Args:
            obj: st.point (X) 一个坐标点
            target: st.point (X) 一个坐标点

        Returns:
            int
        """
        pass

    @staticmethod
    def sign(x: int) -> int:
        """
        返回x的符号
        Args:
            x:

        Returns:
            0, 1, -1
        """
        pass

    @staticmethod
    def find(objs: list | tuple, filter_fn: list | tuple | set | callable) -> object:
        """
        Find the first object that satisfies the condition

        Args:
            objs: list | tuple (X) 待查找的对象列表
            filter_fn: list | tuple | set | callable (X) 容器函数表达式

        Returns:
            object
        """
        pass

    @staticmethod
    def filter(objs: list | tuple, filter_fn: list | tuple | set | callable) -> list:
        """
        Returns a list of objects that satisfy the condition

        Args:
            objs: list | tuple (X) 待查找的对象列表
            filter_fn: list | tuple | set | callable (X) 容器函数表达式

        Returns:
            list
        """
        pass

    @staticmethod
    def classname(game_object: GameObject) -> str:
        """
        获取游戏相关的js对象的类名
        Args:
            game_object: GameObject (X) 游戏对象

        Returns:
            str
        """
        pass

    @staticmethod
    def terrain(x_or_point: int | st.point, y: None | int = None) -> int:
        """
        获取指定位置的地形

        Args:
            x_or_point: int| st.point (X) x坐标或者坐标点
            y: None|int (X) y坐标。 如果传入了y坐标，那么期望的第一个参数x为int类型

        Returns:
            int 地形常量
        """
        pass

    @staticmethod
    def all(p_type: type, filter_fn: list | tuple | set | callable | None = None) -> list:
        """
        获取所有指定类型、指定条件的所有对象

        Args:
            p_type: type (X) 对象的类型
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def one(p_type: type, filter_fn: list | tuple | set | callable | None = None) -> object | None:
        """
        获取所有指定类型、指定条件的一个对象

        Args:
            p_type: type (X) 对象的类型
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            object | None 如果没有找到，返回None
        """
        pass

    @staticmethod
    def creeps(filter_fn: list | tuple | set | callable | None = None) -> list[Creep]:
        """
        获取所有满足条件的Creep

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def creep(filter_fn: list | tuple | set | callable | None = None) -> Creep | None:
        """
        获取一个满足条件的Creep

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Creep 如果没有找到，返回None
        """
        pass

    @staticmethod
    def friends(filter_fn: list | tuple | set | callable | None = None) -> list[GameObject]:
        """
        获取所有满足条件的友方对象

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def friend(filter_fn: list | tuple | set | callable | None = None) -> GameObject | None:
        """
        获取一个满足条件的友方对象

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            GameObject 如果没有找到，返回None

        Examples:
            ```python
            # 获取SpawnSwamp模式下的基地Spawn
            spawn = get.friend(st.spawn)
            # 方式2
            spawn = get.spawn(st.friend)
            ```
        """
        pass

    @staticmethod
    def enemies(filter_fn: list | tuple | set | callable | None = None) -> list[GameObject]:
        """
        获取所有满足条件的敌方对象

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def enemy(filter_fn: list | tuple | set | callable | None = None) -> GameObject | None:
        """
        获取一个满足条件的敌方对象

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            GameObject 如果没有找到，返回None
        """
        pass

    @staticmethod
    def spawns(filter_fn: list | tuple | set | callable | None = None) -> list[StructureSpawn]:
        """
        获取所有满足条件的Spawn

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def spawn(filter_fn: list | tuple | set | callable | None = None) -> StructureSpawn | None:
        """
        获取一个满足条件的Spawn

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureSpawn 如果没有找到，返回None
        """
        pass

    @staticmethod
    def structures(filter_fn: list | tuple | set | callable | None = None) -> list[Structure]:
        """
        获取所有满足条件的Structure

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def structure(filter_fn: list | tuple | set | callable | None = None) -> Structure | None:
        """
        获取一个满足条件的Structure

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Structure 如果没有找到，返回None
        """
        pass

    @staticmethod
    def sources(filter_fn: list | tuple | set | callable | None = None) -> list[Source]:
        """
        获取所有满足条件的Source

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def source(filter_fn: list | tuple | set | callable | None = None) -> Source | None:
        """
        获取一个满足条件的Source

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Source 如果没有找到，返回None
        """
        pass

    @staticmethod
    def sites(filter_fn: list | tuple | set | callable | None = None) -> list[ConstructionSite]:
        """
        获取所有满足条件的ConstructionSite

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def site(filter_fn: list | tuple | set | callable | None = None) -> ConstructionSite | None:
        """
        获取一个满足条件的ConstructionSite

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            ConstructionSite 如果没有找到，返回None
        """
        pass

    @staticmethod
    def resources(filter_fn: list | tuple | set | callable | None = None) -> list[Resource]:
        """
        获取所有满足条件的Resource

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def resource(filter_fn: list | tuple | set | callable | None = None) -> Resource | None:
        """
        获取一个满足条件的Resource

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Resource 如果没有找到，返回None
        """
        pass

    @staticmethod
    def towers(filter_fn: list | tuple | set | callable | None = None) -> list[StructureTower]:
        """
        获取所有满足条件的Tower

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def tower(filter_fn: list | tuple | set | callable | None = None) -> StructureTower | None:
        """
        获取一个满足条件的Tower

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureTower 如果没有找到，返回None
        """
        pass

    @staticmethod
    def walls(filter_fn: list | tuple | set | callable | None = None) -> list[StructureWall]:
        """
        获取所有满足条件的Wall

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def wall(filter_fn: list | tuple | set | callable | None = None) -> StructureWall | None:
        """
        获取一个满足条件的Wall

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureWall 如果没有找到，返回None
        """
        pass

    @staticmethod
    def ramparts(filter_fn: list | tuple | set | callable | None = None) -> list[StructureRampart]:
        """
        获取所有满足条件的Rampart

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def rampart(filter_fn: list | tuple | set | callable | None = None) -> StructureRampart | None:
        """
        获取一个满足条件的Rampart

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureRampart 如果没有找到，返回None
        """
        pass

    @staticmethod
    def extensions(filter_fn: list | tuple | set | callable | None = None) -> list[StructureExtension]:
        """
        获取所有满足条件的Extension

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def extension(filter_fn: list | tuple | set | callable | None = None) -> StructureExtension | None:
        """
        获取一个满足条件的Extension

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureExtension 如果没有找到，返回None
        """
        pass

    @staticmethod
    def boxes(filter_fn: list | tuple | set | callable | None = None) -> list[StructureContainer]:
        """
        获取所有满足条件的Container

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def box(filter_fn: list | tuple | set | callable | None = None) -> StructureContainer | None:
        """
        获取一个满足条件的Container

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureContainer 如果没有找到，返回None
        """
        pass

    @staticmethod
    def roads(filter_fn: list | tuple | set | callable | None = None) -> list[StructureRoad]:
        """
        获取所有满足条件的Road

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def road(filter_fn: list | tuple | set | callable | None = None) -> StructureRoad | None:
        """
        获取一个满足条件的Road

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            StructureRoad 如果没有找到，返回None
        """
        pass

    @staticmethod
    def flags(filter_fn: list | tuple | set | callable | None = None) -> list[Flag]:
        """
        获取所有满足条件的Flag

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def flag(filter_fn: list | tuple | set | callable | None = None) -> Flag | None:
        """
        获取一个满足条件的Flag

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            Flag 如果没有找到，返回None
        """
        pass

    @staticmethod
    def score_controllers(filter_fn: list | tuple | set | callable | None = None) -> list[ScoreController]:
        """
        获取所有满足条件的ScoreController

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def score_controller(filter_fn: list | tuple | set | callable | None = None) -> ScoreController | None:
        """
        获取一个满足条件的ScoreController

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            ScoreController 如果没有找到，返回None
        """
        pass

    @staticmethod
    def storages(filter_fn: list | tuple | set | callable | None = None) -> list[GameObject]:
        """
        获取所有满足条件的Storage

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def storage(filter_fn: list | tuple | set | callable | None = None) -> GameObject | None:
        """
        获取一个满足条件的Storage

        Args:
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            GameObject 如果没有找到，返回None
        """
        pass

    @staticmethod
    def moved(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过移动命令

        * 只能判断由put下达的移动命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def attacked(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过攻击命令

        * 只能判断由put下达的攻击命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def meleed(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过近战攻击命令

        * 只能判断由put下达的攻击命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def ranged(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过远程攻击命令

        * 只能判断由put下达的攻击命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def healed(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过治疗命令

        * 只能判断由put下达的治疗命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def fetched(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过拿取命令

        * 只能判断由put下达的拿取命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def deposited(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过放置命令

        * 只能判断由put下达的放置命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def built(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过建造命令

        * 只能判断由put下达的建造命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def intermited(unit: st.creep, ticks_offset: int = 0) -> bool:
        """
        判断单位当前tick是否被下达过intermit命令

        * 只能判断由put下达的放置命令

        Args:
            unit: st.creep (X) 一个Creep对象
            ticks_offset: int (X) 偏移的ticks数, 默认为0. 比如传入-1表示上一tick

        Returns:
            bool
        """
        pass

    @staticmethod
    def closest(obj: st.point, objs: list[st.point], filter_fn: list | tuple | set | callable | None = None) -> st.point | None:
        """
        返回距离最近的对象

        Args:
            obj: st.point (X) 一个坐标点
            objs: list[st.point] (X) 一个坐标点列表
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            st.point | None 如果没有找到，返回None
        """
        pass

    @staticmethod
    def quickest(obj: st.point, objs: list[st.point], filter_fn: list | tuple | set | callable | None = None) -> st.point | None:
        """
        返回移动到目标所需时间最短的对象

        Args:
            obj: st.point (X) 一个坐标点
            objs: list[st.point] (X) 一个坐标点列表
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            st.point | None 如果没有找到，返回None
        """
        pass

    @staticmethod
    def inrange(obj: st.point, objs: list[st.point], range: int, filter_fn: list | tuple | set | callable | None = None) -> list[st.point]:
        """
        返回在指定范围内的对象列表

        Args:
            obj: st.point (X) 一个坐标点
            objs: list[st.point] (X) 一个坐标点列表
            range: int (X) 查找的最大范围距离
            filter_fn: list | tuple | set | callable | None (X) 条件容器函数表达式

        Returns:
            list 如果没有找到，返回空列表
        """
        pass

    @staticmethod
    def energy(target: st.storable, percent: bool = False) -> int:
        """
        获取目标的能量值

        Args:
            target: st.storable (X) 一个可存储资源的游戏对象
            percent: bool (X) 是否返回百分比

        Returns:
            int | bool 没有cmp字符串时，如果percent为True，返回百分比[0, 100]，否则返回具体能量值int

        """
        pass

    @staticmethod
    def health(target: st.hitable, percent: bool = False) -> int:
        """
        获取目标的生命值

        Args:
            target: st.hitable (X) 一个可被攻击的游戏对象
            percent: bool (X) 是否返回百分比

        Returns:
            int | bool 没有cmp字符串时，如果percent为True，返回百分比[0, 100]，否则返回具体生命值int
        """
        pass

    @staticmethod
    def parts(creep: st.creep, broken: bool = True) -> list[str]:
        """
        获取creep的parts信息

        Args:
            creep: st.creep (X) 一个Creep对象
            broken: bool (X) 是否包含完全损坏的部件. False时可以忽略hit = 0的部件

        Returns:
            list[str]  返回一个列表，包含了目标creep的所有部件(字符串形式). 如果获取失败，返回空列表
        """
        pass

    @staticmethod
    def pcount(creep: st.creep, part_type: str, broken: bool = True) -> int:
        """
        获取creep的body中指定类型的部件数量

        Args:
            creep: st.creep (X) 一个Creep对象
            part_type: str (X) 部件类型, 如MOVE, CARRY, ATTACK, WORK, RANGED_ATTACK 等
            broken: bool (X) 是否包含完全损坏的部件. False时可以忽略hit = 0的部件

        Returns:
            int  返回指定类型的部件数量. 如果获取失败，返回-1

        """
        pass

    @staticmethod
    def pfirst(creep: st.creep) -> UsrObject | None:
        """
        获取creep的body中第一个未完全损坏的部件

        Args:
            creep: st.creep (X) 一个Creep对象

        Returns:
            BodyPart 如果获取失败，返回None
        """
        pass

    @staticmethod
    def plast(creep: st.creep) -> UsrObject | None:
        """
        获取creep的body中最后一个完全损坏的部件

        Args:
            creep: st.creep (X) 一个Creep对象

        Returns:
            BodyPart 如果获取失败，返回None
        """
        pass

    @staticmethod
    def wait(creep: st.creep) -> int:
        """
        获取目标creep需要等待多少tick后才能进行移动

        Args:
            creep: st.creep (X) 一个Creep对象

        Returns:
            int  返回等待的tick数. 如果获取失败，返回-1. 如果目标无法移动，返回0xffff
        """
        pass

    @staticmethod
    def offset(pos: st.point, dx: float, dy: float) -> st.point:
        """
        返回一个新的坐标点，位移dx, dy

        Args:
            pos: st.point (X) 一个坐标点
            dx: float (X) x轴位移, 单位为方块
            dy: float (X) y轴位移, 单位为方块

        Returns:
            st.point  返回一个新的坐标点
        """
        pass

    @staticmethod
    def score(creep, dhp: int = None) -> int:
        """
        为Creep评分
        Args:
            creep:
            dhp: int >0: 用于评估治疗效果。传入后只给出delta量

        Returns:

        """
        pass


class put:
    """
    标准命令输出函数库
    """
    _spawn_memory = []  # 用于存储spawn生产信息的memory

    @staticmethod
    def move(unit: st.friend & st.movable, to: st.point | int, options: UsrObject = None, __assert: bool = True) -> int:
        """
        命令Creep移动到目标点或向某个方向移动

        Args:
            unit: st.friend & st.movable  一个可移动的友方单位
            to: st.point | int 一个目标点或是一个方向
            options: Options  寻路选项(只在to为st.point时有效)
            __assert: bool 是否进行参数检查

        Returns:
            成功返回OK(0)，否则返回错误码(<0)
        """
        pass

    @staticmethod
    def push(unit: st.friend & st.movable, target: st.friend & st.movable, __assert: bool = True) -> int:
        """
        命令一个Creep推动目标Creep

        Args:
            unit: st.friend & st.movable  一个可移动的友方单位
            target: st.friend & st.movable 一个可移动的友方单位
            __assert: bool 是否进行参数检查

        Returns:
            成功返回OK(0)，否则返回错误码(<0)
        """
        pass

    @staticmethod
    def attack(unit: st.friend & st.atkable, target: st.enemy & st.hitable, move: bool | UsrObject = True, __assert: bool = True) -> UsrObject:
        """
        命令Tower或Creep攻击敌方目标

        Args:
            unit: st.friend & st.atkable  一个友方的可攻击单位，例如：*.attack is not undefined
            target: st.enemy & st.hitable  一个敌方的可被攻击的单位
            move: bool | Options  是否可以自主移动(可以传入options, 视作True，用于调整移动时的路线)
            __assert: bool 是否进行参数检查

        Returns:
            Result (如果没有执行某条操作，则不包含对应属性)

                .melee: int 发动近战攻击时记录对应的返回值(成功返回OK(0)，否则返回错误码(<0))

                .ranged: int 发动远程攻击时记录对应的返回值(成功返回OK(0)，否则返回错误码(<0))

                .move: int   移动时记录对应的返回值(成功返回OK(0)，否则返回错误码(<0))

        """
        pass

    @staticmethod
    def heal(unit: st.friend & st.healable, target: st.friend & st.creep, move: bool | UsrObject = True, __assert: bool = True) -> UsrObject:
        """
        命令Tower或Creep治疗目标单位

        Args:
            unit: st.friend & st.healable  一个友方的具有治疗能力的单位
            target: st.friend & st.creep  一个友方的creep
            move: bool | Options  是否可以自主移动(可以传入options, 视作True，用于调整移动时的路线)
            __assert: bool 是否进行参数检查

        Returns:
            UsrObject (如果没有执行某条操作，则不包含对应属性)

                .heal: int 近距离治疗时记录对应的返回值(成功返回OK(0)，否则返回错误码(<0))

                .ranged: int 远程治疗时记录对应的返回值(成功返回OK(0)，否则返回错误码(<0))

                .move: int   移动时记录对应的返回值(成功返回OK(0)，否则返回错误码(<0))
        """
        pass

    @staticmethod
    def fetch(unit: st.friend & st.storable, target: st.storable | st.resource, resource_type: int = RESOURCE_ENERGY, amount: int | None = None,
              move: bool | UsrObject = True,
              __assert: bool = True) -> int:
        """
        命令单位从目标处取出资源

        Args:
            unit: st.friend & st.storable  一个友方的可携带资源的单位
            target: st.storable | st.resource 一个可存储的目标或掉落的资源
            resource_type: int 资源类型, 默认RESOURCE_ENERGY
            amount: int | None 资源数量，如果没有指定，则取出所有资源
            move: bool | Options 是否可以自主移动(可以传入options, 视作True，用于调整移动时的路线)
            __assert: bool 是否进行参数检查

        Returns:
            int 成功返回OK(0)，否则返回错误码(<0)
        """
        pass

    @staticmethod
    def deposit(unit: st.friend & st.storable, target: st.point | None, resource_type: int = RESOURCE_ENERGY, amount: int | None = None,
                move: bool | UsrObject = True, __assert: bool = True) -> int:
        """
        命令单位将身上的资源放置于目标处

        Args:
            unit: st.friend & st.storable  一个友方的可携带资源的单位
            target: st.point | None 将资源放置到坐标点(如果target具有st.storable属性，则将资源放置到该目标)|None表示原地丢弃
            resource_type: int 资源类型, 默认RESOURCE_ENERGY
            amount: int | None 资源数量，如果没有指定，则转移所有资源
            move: bool | Options 是否可以自主移动(可以传入options, 视作True，用于调整移动时的路线)
            __assert: bool 是否进行参数检查

        Returns:
            int 成功返回OK(0)，否则返回错误码(<0)

        Examples:
            ```python
            # 让worker采集资源并把采集到的资源运回spawn
            worker = get.friend(lambda obj: obj.name == 'worker')
            spawn = get.spawn(st.friend)
            source = get.source()
            if get.energy(worker, True) == 100:
                put.deposit(worker, spawn, RESOURCE_ENERGY)
            else:
                put.harvest(worker, source)
            ```
            ```python
            # 让carrier从box不停地取出资源并把资源丢在地上
            carrier = get.friend(lambda obj: obj.name == 'carrier')
            box = get.closest(carrier, get.boxes())
            if get.energy(box) > 0:
                if get.energy(carrier) == 0:
                    put.fetch(carrier, box, RESOURCE_ENERGY)
                else:
                    put.deposit(carrier, None, RESOURCE_ENERGY)
            ```
            ```python
            # 让carrier从box取出资源并把资源送给worker
            carrier = get.friend(lambda obj: obj.name == 'carrier')
            worker = get.friend(lambda obj: obj.name == 'worker')
            box = get.closest(carrier, get.boxes(combo( {st.empty} )))  # 最近的非空box
            if get.energy(carrier, True) > 50:  # 自身带有50%以上的能量就先给worker
                put.deposit(carrier, worker, RESOURCE_ENERGY)
            elif box:
                put.fetch(carrier, box, RESOURCE_ENERGY)
            ```
        """
        pass

    @staticmethod
    def build(unit: st.friend & st.workable, site: st.site, move: bool | UsrObject = True, __assert: bool = True) -> int:
        """
        命令单位建造建筑

        Args:
            unit: st.friend & st.workable  一个友方的可工作单位
            site: st.site 一个ConstructionSite实例对象
            move: bool | Options 是否可以自主移动(可以传入options, 视作True，用于调整移动时的路线)
            __assert: bool 是否进行参数检查

        Returns:
            int 成功返回OK(0)，否则返回错误码(<0)
        """
        pass

    @staticmethod
    def harvest(unit: st.friend & st.workable, target: st.source, move: bool | UsrObject = True, __assert: bool = True) -> int:
        """
        命令单位采集资源

        Args:
            unit: st.friend & st.workable  一个友方的可工作单位
            target: st.source 一个资源点
            move: bool | Options 是否可以自主移动(可以传入options, 视作True，用于调整移动时的路线)
            __assert: bool 是否进行参数检查

        Returns:
            int 成功返回OK(0)，否则返回错误码(<0)

        Examples:
            ```python
            # 让worker采集资源(装满了就回家，否则就继续采集)
            worker = get.friend(lambda obj: obj.name == 'worker')
            spawn = get.spawn(st.friend)
            source = get.source()
            if get.energy(worker, True) == 100:
                put.deposit(worker, spawn, RESOURCE_ENERGY)
            else:
                put.harvest(worker, source)
            ```
        """
        pass

    @staticmethod
    def escape(unit: st.friend & st.movable, target: st.point, options: UsrObject = None, __assert: bool = True) -> int:
        """
        命令Creep远离目标

        ! 不是很好的逃离算法，只是一个简单的逃跑算法(尝试过传入.flee，但是貌似不工作)

        Args:
            unit: st.friend & st.movable  一个可移动的友方单位
            target: st.point 目标点
            options: Options  寻路选项
            __assert: bool 是否进行参数检查

        Returns:
            int 成功返回OK(0)，否则返回错误码(<0)

        Examples:
            ```python
            # 让worker远离最近的敌人
            worker = get.friend(lambda obj: obj.name == 'worker')
            enemy = get.closest(worker, get.enemies())
            if enemy and get.distance(worker, enemy) <= 8:
                put.escape(worker, enemy)
            ```
        """
        pass

    @staticmethod
    def intermit(unit: st.friend & st.storable & st.movable, target: st.point, resource_type: int = RESOURCE_ENERGY, options: UsrObject = None,
                 __assert: bool = True) -> int:
        """
        断断续续地搬运资源到目标

        * 特别适用于空载和满载状态下移动能力差距巨大的单位

        Args:
            unit: st.friend & st.storable & st.movable  一个友方的可移动的可存储资源的单位
            target: st.point 目标点(放置于地上或放置于target。取决于target是否st.storable)
            resource_type: int 资源类型, 默认RESOURCE_ENERGY
            options: Options  寻路选项
            __assert: bool 是否进行参数检查

        Returns:
            int 成功搬运完毕或是无资源可搬运，返回DONE(1); 搬运中返回OK(0)或是错误码(<0)

        Examples:
            ```python
            # 将身上或地上的资源搬运回家(确保身上或地上有资源)
            carrier = get.friend(lambda obj: obj.name == 'carrier')
            spawn = get.spawn(st.friend)
            put.intermit(carrier, spawn, RESOURCE_ENERGY)
            ```
        """
        pass

    @staticmethod
    def follow(unit: st.friend & st.movable, target: st.movable, distance: int | tuple, options: UsrObject = None,
               move: bool | UsrObject = True, __assert: bool = True) -> int:
        """
        命令一个或多个单位跟随目标(可以是尾随，Creep祟祟)

        * 跟随友方时，distance为距离最大值，超出距离(且启用move)时将命令target主动靠近unit(或最远的unit)

        * 跟随敌方时，distance为距离最小值

        Args:
            unit: st.friend & st.movable  一个可移动的友方单位
            target: st.point  一个目标点
            distance: int | tuple 最大或最小距离, tuple: 距离范围, 只在友方时有效(允许忽略过于遥远的友方跟随者)。否则将[0]作为参数
            options: Options  unit进行移动时的move options
            move: bool | Options  友方target是否会回靠(的options)
            __assert: bool 是否进行参数检查

        Returns:
            int 成功返回OK(0)，否则返回错误码(<0)

        Examples:
            ```python
            leader = get.friend(lambda obj: obj.name == 'leader')
            warriors = get.friends(lambda obj: obj.name == 'warrior')
            # warriors跟随leader，距离不超过5。leader不考虑距离超过20的warrior。
            put.follow(warriors, leader, (5, 20))
            ```
        """
        pass

    @staticmethod
    def carry(unit: st.friend & st.storable & st.movable, src: st.storable, dst: st.storable, resource_type: int = RESOURCE_ENERGY,
              options: UsrObject = None, intermit: bool = False,
              __assert: bool = True) -> int:
        """
        命令单位从src处搬运资源到dst处

        Args:
            unit: st.friend & st.storable & st.movable  一个友方的可携带资源的可移动单位
            src: st.storable  从哪里取得资源
            dst: st.storable  被搬运资源的目标容器
            resource_type: int 资源类型, 默认RESOURCE_ENERGY
            options: Options  寻路选项
            intermit: bool 是否断断续续地搬运资源
            __assert: bool 是否进行参数检查

        Returns:
            int 若intermit=False，成功返回OK(0)，否则返回错误码(<0); 若intermit=True，则在搬运完毕或是无资源可搬运时，返回DONE(1)，其余和前者相同

        Examples:
            ```python
            # 将身上的资源搬运回家(确保身上有资源)
            carrier = get.friend(lambda obj: obj.name == 'carrier')
            spawn = get.spawn(st.friend)
            box = get.closest(carrier, get.boxes(st.energetic))
            put.carry(carrier, box, spawn, RESOURCE_ENERGY)
            ```
        """
        pass

    @staticmethod
    def site(x_pos: int | float | Point, y_type: int | float | type, building_type: type | None = None, single: bool = False, __assert=True) -> int | ConstructionSite:
        """
        创建一个ConstructionSite

        Args:
            x_pos: int | float | Position  x坐标或Position对象
            y_type: int | float | type  y坐标或建筑类型
            building_type: type | None  建筑类型
            single: bool  是否只允许创建一个ConstructionSite
            __assert: bool 是否进行参数检查(un use at here)

        Returns:
            int | ConstructionSite
        """
        pass

    @staticmethod
    def create(spawn: st.friend & st.spawn, recipe: list[str], name: str | None = None, __assert: bool = True) -> int | Creep:
        """
        命令spawn按照指定的配方生产一个creep

        Args:
            spawn: st.friend & st.spawn 一个友方的Spawn
            recipe: list[str]  一个creep的配方, 一般用const下的MOVE, CARRY, WORK等常量
            name: str | None  一个creep的名字(默认为None), 这样创建的creep会带有.name属性
            __assert: bool 是否进行参数检查

        Returns:
            int | object 如果成功(生产完成)，返回创建的creep对象; 否则返回错误码(<0)

        Examples:
            ```python
            # 生成一个名为'worker'的creep
            spawn = get.spawn(st.friend)
            worker = get.friend(lambda obj: obj.name == 'worker')
            if not worker:
                put.create(spawn, [CARRY, MOVE, WORK], 'worker')
            ```
        """
        pass
